<script lang="ts">
    import { describeData } from '../common/describe'
    import { readHnetFile } from '../common/hnetFileFormat'
    import type { HnetData } from '../common/hnetFileFormat'

    import { description } from '../common/description'
    import { associations } from '../common/associations'
    import { options } from './options'

    export let error: string | undefined

    let formElement: HTMLFormElement

    let over = false
    let uploading = false

    function prevent(e: DragEvent) {
        e.preventDefault()
        e.stopPropagation()
    }

    function dragEnter(e: DragEvent) {
        over = true
        e.preventDefault()
        e.stopPropagation()
    }

    function dragLeave(e: DragEvent) {
        over = false
        e.preventDefault()
        e.stopPropagation()
    }

    function drop(e: DragEvent) {
        e.preventDefault()
        e.stopPropagation()

        over = false
        const files = e.dataTransfer.files

        upload(files[0])
    }

    function inputChanged(event: Event): void {
        const formData = new FormData(formElement);
        const file = formData.get('file') as File
        if (file) {
            upload(file)
        }
    }

    function upload(file: File) {
        uploading = true
        $description = undefined
        error = undefined

        if (file.name.endsWith('.hnet')) {
            console.log('Reading HNet file')

            readHnetFile(file)
                .then((data: HnetData) => {
                    $description = data.description
                    $description.filename = file.name
                    $options = data.options
                    $associations = data.associations

                    uploading = false
                })
                .catch((e: any) => {
                    uploading = false
                    error = e.message ?? String(e)
                    console.error(e)
                })

        } else {
            describeData(file)
                .then((d) => {
                    uploading = false
                    $description = d
                })
                .catch((e: Error) => {
                    uploading = false
                    error = e.message
                    console.error(e)
                })
        }
    }


</script>

<form action="" enctype="multipart/form-data" bind:this={formElement}
      on:drag={prevent} on:dragstart={prevent}
      on:dragover={dragEnter} on:dragenter={dragEnter}
      on:dragend={dragLeave} on:dragleave={dragLeave}
      on:drop={drop}
      class="m-4 border-2 border-dashed border-donkerblauw rounded p-8 text-center text-xl"
      class:bg-donkerblauw-1={over}
      class:initial={!$description}
>
    {#if !uploading}
        <input id="file" name="file" type="file" class="hidden" on:change={inputChanged}>
        <label for="file"
               class="h-full block cursor-pointer text-donkerblauw hover:text-donkerblauw-hover"
        >

            Select a file or drag it here
        </label>
    {:else}
        <!--        Processing data-->
        <svg class="animate-spin h-5 w-5 inline" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24">
            <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
            <path class="opacity-75" fill="currentColor"
                  d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"></path>
        </svg>
    {/if}

</form>

<style>
    form.initial {
        min-height: calc(100vh - 240px);
    }
</style>

